﻿Imports Microsoft.Win32
Imports VidGrabNoForm

Class Window1
    Public Vg As VideoGrabberWPF

    Public Sub New()
        InitializeComponent()
        Vg = New VideoGrabberWPF()
        AddHandler Me.Vg.OnFrameRefresh, New VideoGrabberWPF.OnFrameRefreshEventHandler(AddressOf VideoGrabber_OnFrameRefresh)
    End Sub

    Private Sub VideoGrabber_OnFrameRefresh(ByVal sender As Object, ByVal e As VideoGrabberWPF.TOnFrameRefreshEventArgs)
        image1.Source = e.BitmapSource
    End Sub

    Private Sub image1_SizeChanged(ByVal sender As System.Object, ByVal e As System.Windows.SizeChangedEventArgs)
        ' this resizes the TVideoGrabber component to the size of the WPF control, disable this code if needed
        Vg.Width = image1.Width
        Vg.Height = image1.Height
    End Sub

    Private Sub StartRendering_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ' starts the TVideoGrabber WPF rendering, the TVideoGrabber component is supposed to be already previewing or playing
        Vg.Start()
    End Sub

    Private Sub StopRendering_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ' stops the TVideoGrabber WPF rendering, this does not stop the TVideoGrabber component that goes on previewing or playing in the background
        Vg.Stop()
    End Sub

    Private Sub OneShot_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ' renders one frame. This stops the wpf rendering if Vg.Start() has been invoked previously. This does not stop the TVideoGrabber component that goes on previewing or playing in the background
        Vg.OneShot()
    End Sub

    Private Sub StartPreview_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Vg.VideoGrabber.VideoSource = TVideoSource.vs_ScreenRecording
        Vg.VideoGrabber.StartPreview()
        Vg.FrameRate = 30.0
    End Sub

    Private Sub StopPreview_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Vg.VideoGrabber.StopPreview()
    End Sub

    Public Const AUDIO_CLIPS As String = "*.mp3;*.wav;*.wma;*.mid"
    Public Const VIDEO_CLIPS As String = "*.mp*;*.vro;*.avi;*.asf;*.wmv;*.vob;*.avs;*.mov;*.divx;*.mp4;*.mts;*.3gp;*.swf;*.m2v;*.mkv;*.flv;*.wemb;*.ts;*.m4v;*.mp4v"
    Public Const IMAGE_FILES As String = "*.jpg;*.jpeg;*.jpe;*.bmp;*.gif;*.png"
    Public Const OPEN_MEDIA_FILES As String = "All media files|" & VIDEO_CLIPS & AUDIO_CLIPS & IMAGE_FILES & "|Video clips|" & VIDEO_CLIPS & "|Audio clips|" & AUDIO_CLIPS
    Public Const OPEN_MEDIA_FILES_EXTENDED As String = OPEN_MEDIA_FILES & "|Image files|" & IMAGE_FILES
    Public Const OPEN_PICTURE_FILES As String = "Image files|*.bmp;*.jpg;*.gif;*.png;*.tif;*.tiff;*.wmf;*.emf;*.exf;*.jpe;*.jpeg"

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        Dim fd As New OpenFileDialog()

        fd.Filter = OPEN_MEDIA_FILES_EXTENDED
        If fd.ShowDialog() = True Then
            Vg.FrameRate = 30.0
            Vg.VideoGrabber.PlayerFileName = fd.FileName
            Vg.VideoGrabber.OpenPlayer()
        End If
    End Sub

    Private Sub CloseClip_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles CloseClip.Click
        Vg.VideoGrabber.ClosePlayer()
    End Sub
End Class
